#include "syhi.h"
#include <sys/types.h>
#include <string.h>
#include <pcre.h>
#include <stdio.h>

#include <assert.h>

void highlight(GtkTextView *view)
{
	GtkTextIter start, end;
	GtkTextBuffer *buf;
	int textlen;

	GtkTextTag* tag;

	const char *error;
	int erroffset;
	int sub[12];
	const char *pattern;
	int num;
	
	int startidx = 0, retval;
	char *text, *mytext;

	pcre *pbuf;
	
	buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
	textlen = gtk_text_buffer_get_char_count(buf);
	tag = gtk_text_buffer_create_tag(buf, "mytag", "background", "red", NULL);
	
	gtk_text_buffer_get_bounds(buf, &start, &end);
	text = gtk_text_buffer_get_text(buf, &start, &end, TRUE);
			
	pattern = strdup("(?:^|;)(?:\\s*)([_a-z0-9:]{1,})([\\s\\*]{1,})([_a-z0-9]{1,})(,[\\s\\*]*[_a-z0-9]{1,})*(\\s*=\\s*.*|\\s*\\(.*\\)*?)*(\\s*)(;)");
	
	pbuf = pcre_compile(pattern, PCRE_MULTILINE | PCRE_CASELESS, &error, &erroffset, NULL);
	
	if (pbuf == NULL)
	{
		printf("error compiling regex at char %d: %s\n", erroffset, error);
		return;
	}

	retval = pcre_exec(pbuf, NULL, text, strlen(text), startidx, 0, sub, 12);
	printf("first retval is %d, textlen is %d\n", retval, textlen);
	
	while (retval >= 0 && sub[2] < textlen)
	{		
		printf("enter loop\n");
		//assert(myregs != NULL);
		
		//get iters at submatch position(s)
		gtk_text_buffer_get_iter_at_offset(buf, &start, sub[2]);
		gtk_text_buffer_get_iter_at_offset(buf, &end, sub[3]);
		
		printf("match: %d - %d\n", sub[2], sub[3]);
		gtk_text_buffer_apply_tag_by_name(buf, "mytag", &start, &end);
		
		startidx = sub[3] + 1;
		
		retval = pcre_exec(pbuf, NULL, text, strlen(text), startidx, 0, sub, 12);
		printf("retval: %d\n", retval);
	}
	

	printf("returning...\n");
						
	return;
}
